## libsemanage 2.3

=== src/Makefile ===
# Support building the Python bindings multiple times, against various Python
# runtimes (e.g. Python 2 vs Python 3) by optionally prefixing the build
# targets with "PYPREFIX":
PYTHON ?= python
PYPREFIX ?= $(notdir $(PYTHON))
RUBY ?= ruby
RUBYPREFIX ?= $(notdir $(RUBY))

# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(PREFIX)/lib
INCLUDEDIR ?= $(PREFIX)/include
PYLIBVER ?= $(shell $(PYTHON) -c 'import sys;print("python%d.%d" % sys.version_info[0:2])')
PYINC ?= $(shell pkg-config --cflags $(PYPREFIX))
PYLIBDIR ?= $(LIBDIR)/$(PYLIBVER)
RUBYLIBVER ?= $(shell $(RUBY) -e 'print RUBY_VERSION.split(".")[0..1].join(".")')
RUBYPLATFORM ?= $(shell $(RUBY) -e 'print RUBY_PLATFORM')
RUBYINC ?= $(shell pkg-config --cflags ruby-$(RUBYLIBVER))
RUBYINSTALL ?= $(LIBDIR)/ruby/site_ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)

LIBBASE=$(shell basename $(LIBDIR))

DEFAULT_SEMANAGE_CONF_LOCATION=$(DESTDIR)/etc/selinux/semanage.conf

ifeq ($(DEBUG),1)
	export CFLAGS = -g3 -O0 -gdwarf-2 -fno-strict-aliasing -Wall -Wshadow -Werror
	export LDFLAGS = -g
endif

LEX = flex
LFLAGS = -s
YACC = bison
YFLAGS = -d

VERSION = $(shell cat ../VERSION)
LIBVERSION = 1

LIBA=libsemanage.a
TARGET=libsemanage.so
LIBPC=libsemanage.pc
SWIGIF= semanageswig_python.i semanageswig_python_exception.i
SWIGRUBYIF= semanageswig_ruby.i
SWIGCOUT= semanageswig_wrap.c
SWIGRUBYCOUT= semanageswig_ruby_wrap.c
SWIGLOBJ:= $(patsubst %.c,$(PYPREFIX)%.lo,$(SWIGCOUT))
SWIGRUBYLOBJ:= $(patsubst %.c,$(RUBYPREFIX)%.lo,$(SWIGRUBYCOUT)) 
SWIGSO=$(PYPREFIX)_semanage.so
SWIGFILES=$(SWIGSO) semanage.py 
SWIGRUBYSO=$(RUBYPREFIX)_semanage.so
LIBSO=$(TARGET).$(LIBVERSION)

GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) semanageswig_python_exception.i
SRCS= $(filter-out $(GENERATED),$(wildcard *.c))

OBJS= $(patsubst %.c,%.o,$(SRCS)) conf-scan.o conf-parse.o
LOBJS= $(patsubst %.c,%.lo,$(SRCS)) conf-scan.lo conf-parse.lo
CFLAGS ?= -Werror -Wall -W -Wundef -Wshadow -Wmissing-noreturn -Wmissing-format-attribute

SWIG_CFLAGS += -Wno-error -Wno-unused-but-set-variable -Wno-unused-variable -Wno-shadow \
		-Wno-unused-parameter

override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE 
RANLIB=ranlib

SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./

SWIGRUBY = swig -Wall -ruby -o $(SWIGRUBYCOUT) -outdir ./

GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) $(wildcard conf-*.[ch])

all: $(LIBA) $(LIBSO) $(LIBPC)

pywrap: all $(SWIGSO)

rubywrap: all $(SWIGRUBYSO)

$(SWIGLOBJ): $(SWIGCOUT)
	$(CC) $(CFLAGS) $(SWIG_CFLAGS) $(PYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGRUBYLOBJ): $(SWIGRUBYCOUT)
	$(CC) $(CFLAGS) $(SWIG_CFLAGS) $(RUBYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGSO): $(SWIGLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $< -L. -lsemanage -L$(LIBDIR)

$(SWIGRUBYSO): $(SWIGRUBYLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lsemanage -L$(LIBDIR)

$(LIBA): $(OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(LIBSO): $(LOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -lsepol -laudit -lselinux -lbz2 -lustr -L$(LIBDIR) -Wl,-soname,$(LIBSO),--version-script=libsemanage.map,-z,defs
	ln -sf $@ $(TARGET)

$(LIBPC): $(LIBPC).in ../VERSION
	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBBASE):; s:@includedir@:$(INCLUDEDIR):' < $< > $@

semanageswig_python_exception.i: ../include/semanage/semanage.h
	bash exception.sh > $@

conf-scan.c: conf-scan.l conf-parse.h
	$(LEX) $(LFLAGS) -t $< > $@

conf-parse.c: conf-parse.y
	$(YACC) $(YFLAGS) -o $@ $<

conf-parse.h: conf-parse.c

%.o:  %.c 
	$(CC) $(CFLAGS) -c -o $@ $<

%.lo:  %.c
	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

conf-parse.o:  conf-parse.c
	$(CC) $(filter-out -Werror, $(CFLAGS)) -c -o $@ $<

conf-parse.lo:  conf-parse.c
	$(CC) $(filter-out -Werror, $(CFLAGS)) -fPIC -DSHARED -c -o $@ $<

conf-scan.o:  conf-scan.c
	$(CC) $(filter-out -Werror, $(CFLAGS)) -c -o $@ $<

conf-scan.lo:  conf-scan.c
	$(CC) $(filter-out -Werror, $(CFLAGS)) -fPIC -DSHARED -c -o $@ $<

$(SWIGCOUT): $(SWIGIF)
	$(SWIG) $<

$(SWIGRUBYCOUT): $(SWIGRUBYIF)
	$(SWIGRUBY) $<

swigify: $(SWIGIF)
	$(SWIG) $<

install: all 
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	test -d $(LIBDIR)/pkgconfig || install -m 755 -d $(LIBDIR)/pkgconfig
	install -m 644 $(LIBPC) $(LIBDIR)/pkgconfig
	test -f $(DEFAULT_SEMANAGE_CONF_LOCATION) || install -m 644 -D semanage.conf $(DEFAULT_SEMANAGE_CONF_LOCATION)
	cd $(LIBDIR) && ln -sf $(LIBSO) $(TARGET)

install-pywrap: pywrap 
	test -d $(PYLIBDIR)/site-packages || install -m 755 -d $(PYLIBDIR)/site-packages
	install -m 755 $(SWIGSO) $(PYLIBDIR)/site-packages/_semanage.so
	install -m 755 semanage.py $(PYLIBDIR)/site-packages


install-rubywrap: rubywrap
	test -d $(RUBYINSTALL) || install -m 755 -d $(RUBYINSTALL) 
	install -m 755 $(SWIGRUBYSO) $(RUBYINSTALL)/semanage.so

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) conf-parse.c conf-parse.h conf-scan.c *.o *.lo *~

distclean: clean
	rm -f $(SWIGCOUT) $(SWIGFILES)

indent:
	../../scripts/Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))

.PHONY: all clean pywrap rubywrap swigify install install-pywrap install-rubywrap distclean

=== tests/Makefile ===
# Add your test source files here:
SOURCES = $(wildcard *.c)

# Point this variable to the libsemanage source directory you want to test:
TESTSRC=../src

# Add the required external object files here:
LIBS = ../src/libsemanage.a ../../libselinux/src/libselinux.a ../../libsepol/src/libsepol.a

###########################################################################

EXECUTABLE = libsemanage-tests
CC = gcc
CFLAGS = -c -g -o0 -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute -Wno-unused-parameter
INCLUDE = -I$(TESTSRC) -I$(TESTSRC)/../include
LDFLAGS = -lcunit -lustr -lbz2 -laudit
OBJECTS = $(SOURCES:.c=.o) 

all: $(EXECUTABLE) 

$(EXECUTABLE): $(OBJECTS) 
	$(CC) $(OBJECTS) $(LIBS) $(LDFLAGS) -o $@

%.o: %.c
	$(CC) $(CFLAGS) $(INCLUDE) $*.c -o $*.o

clean distclean: 
	rm -rf $(OBJECTS) $(EXECUTABLE)

test: all 
	./$(EXECUTABLE)

=== debian/changelog ===
libsemanage (2.3-1build3) xenial; urgency=medium

  * No-change rebuild for ruby2.3 support.

 -- Adam Conrad <adconrad@ubuntu.com>  Wed, 20 Apr 2016 03:53:03 -0600

libsemanage (2.3-1build2) wily; urgency=medium

  * No-change rebuild to add ruby2.2 support.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 09 Sep 2015 16:35:28 +0000

libsemanage (2.3-1build1) vivid; urgency=medium

  * No change rebuild to get debug symbols on all architectures.

 -- Brian Murray <brian@ubuntu.com>  Tue, 02 Dec 2014 11:56:13 -0800

libsemanage (2.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - debian/control: Bump {build-}dependencies to match new release
  * debian/rules: Do not require ruby or python dh helpers when bootstrapping
  * debian/rules: Rework the makefile, it should handle changes in the
    supported ruby versions by binNMU now (Closes: #747685)
  * debian/rules: Fix path in the override_dh_fixperms target

 -- Laurent Bigonville <bigon@debian.org>  Fri, 16 May 2014 16:27:12 +0200

libsemanage (2.2-2) unstable; urgency=medium

  * Team upload.
  [ Hideki Yamane ]
  * debian/{rules,ruby-semanage.install}
    - remove ruby1.9.1 (however, it's just a workaround since it specifies
      only ruby2.0, and we'll move to ruby2.1) (Closes: #746025)

  [ Laurent Bigonville ]
  * debian/rules: Build ruby 2.1 bindings too
  * debian/control: Bump Standards-Version to 3.9.5 (no further changes)

 -- Laurent Bigonville <bigon@debian.org>  Fri, 02 May 2014 02:06:36 +0200

=== debian/control ===
Source: libsemanage
VCS-Git: git://anonscm.debian.org/selinux/libsemanage.git
VCS-Browser: http://anonscm.debian.org/gitweb/?p=selinux/libsemanage.git;a=summary
Priority: optional
Section: libdevel
Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
Uploaders: Manoj Srivastava <srivasta@debian.org>, Russell Coker <russell@coker.com.au>
Standards-Version: 3.9.5
Build-Depends: bison,
               debhelper (>= 9),
               file,
               flex,
               gem2deb (>= 0.5.0~),
               libaudit-dev,
               libbz2-dev,
               libcunit1-dev,
               libselinux1-dev (>= 2.3),
               libsepol1-dev (>= 2.3),
               libustr-dev,
               pkg-config,
               python-all-dev (>= 2.6.6-3~),
               swig
Homepage: http://userspace.selinuxproject.org/
X-Python-Version: >= 2.5
XS-Ruby-Versions: all

Package: libsemanage-common
Architecture: all
Section: libs
Depends: ${misc:Depends}
Breaks: libsemanage1 (<= 2.0.41-1), libsemanage1-dev (<< 2.1.6-3~)
Replaces: libsemanage1 (<= 2.0.41-1), libsemanage1-dev (<< 2.1.6-3~)
Multi-Arch: foreign
Description: Common files for SELinux policy management libraries
 This package provides the common files used by the shared libraries
 for SELinux policy management.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: libsemanage1
Architecture: linux-any
Section: libs
Depends: libsemanage-common (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: SELinux policy management library
 This package provides the shared libraries for SELinux policy management.
 It uses libsepol for binary policy manipulation and libselinux for
 interacting with the SELinux system.  It also exec's helper programs
 for loading policy and for checking whether the file_contexts
 configuration is valid (load_policy and setfiles from
 policycoreutils) presently, although this may change at least for the
 bootstrapping case
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: libsemanage1-dev
Architecture: linux-any
Depends: libbz2-dev,
         libselinux1-dev (>= 2.3),
         libsemanage1 (= ${binary:Version}),
         libsepol1-dev (>= 2.3),
         libustr-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Provides: libsemanage-dev
Conflicts: libsemanage-dev
Description: Header files and libraries for SELinux policy manipulation
 This package provides an API for the management of SELinux policies.
 It contains the static libraries and header files needed
 for developing applications that manage SELinux policies.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: ruby-semanage
Architecture: linux-any
Depends: ruby | ruby-interpreter, ${misc:Depends}, ${shlibs:Depends}
Section: ruby
XB-Ruby-Versions: ${ruby:Versions}
Description: Ruby bindings to for SELinux policy management
 This package provides the Ruby bindings needed for developing Ruby
 applications that manage SELinux policies.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

Package: python-semanage
Architecture: linux-any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Section: python
Description: Python bindings for SELinux policy management
 This package provides Python bindings for the management of SELinux
 policies.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a
 number of utilities with enhanced security functionality designed to
 add mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement, Role-based Access
 Control, and Multi-level Security.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifeq ($(DEB_STAGE),stage1)
export DH_OPTIONS += -Nruby-semanage -Npython-semanage
else
PYVERSIONS = $(shell pyversions -rv)
RUBY_VERSIONS := $(shell dh_ruby --print-supported)
endif

# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

%:
ifeq ($(DEB_STAGE),stage1)
	dh $@
else
	dh $@ --with python2 --with ruby
endif

override_dh_auto_build:
	$(MAKE) all LIBBASE="lib/${DEB_HOST_MULTIARCH}"

ifneq ($(DEB_STAGE),stage1)
	for version in $(PYVERSIONS); do              \
	  $(MAKE) pywrap PYTHON=python$$version  \
	    PYPREFIX=python-$$version;  \
	done;

	for version in $(RUBY_VERSIONS); do              \
	  RUBY_HDRDIR=$$($$version -e 'print RbConfig::CONFIG["rubyhdrdir"]'); \
	  RUBY_ARCH_HDRDIR=$$($$version -e 'print RbConfig::CONFIG["rubyarchhdrdir"]'); \
	  RUBY_VERSION=$$($$version -e 'print RbConfig::CONFIG["ruby_version"]'); \
	  $(MAKE) -C src rubywrap RUBY=$$version RUBYLIBVER=$$RUBY_VERSION \
	    RUBYINC="-I$$RUBY_HDRDIR -I$$RUBY_ARCH_HDRDIR"; \
	done;
endif

override_dh_auto_install:
	$(MAKE) install DESTDIR="${CURDIR}/debian/tmp" \
	  LIBDIR="${CURDIR}/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}" \
	  SHLIBDIR="${CURDIR}/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}"

ifneq ($(DEB_STAGE),stage1)
	for version in $(PYVERSIONS); do              \
	  $(MAKE) install-pywrap PYTHON=python$$version  \
	    DESTDIR="${CURDIR}/debian/tmp" \
	    PYPREFIX=python-$$version;  \
	done;

	for version in $(RUBY_VERSIONS); do              \
	  RUBY_VENDOR_ARCHLIB=$$($$version -e 'print RbConfig::CONFIG["vendorarchdir"]'); \
	  RUBY_VERSION=$$($$version -e 'print RbConfig::CONFIG["ruby_version"]'); \
	  $(MAKE) -C src install-rubywrap RUBY=$$version RUBYLIBVER=$$RUBY_VERSION DESTDIR="${CURDIR}/debian/tmp" \
	      RUBYINSTALL="${CURDIR}/debian/tmp/$$RUBY_VENDOR_ARCHLIB"; \
	done;
endif

override_dh_auto_clean:
ifneq ($(DEB_STAGE),stage1)
	for version in $(PYVERSIONS); do              \
	  $(MAKE) clean PYTHON=python$$version;  \
	done;
endif

override_dh_install:
	dh_install --list-missing

override_dh_fixperms:
	dh_fixperms
	-chmod -x ${CURDIR}/debian/python-semanage/usr/lib/python*/*-packages/semanage.py

override_dh_auto_test:
	$(MAKE) test || true

=== debian/watch ===
version=3

http://userspace.selinuxproject.org/releases/(\d+)/libsemanage-(.*)\.tar\.gz

## libsemanage 2.5

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,31 @@
 Source: libsemanage
-VCS-Git: git://anonscm.debian.org/selinux/libsemanage.git
-VCS-Browser: http://anonscm.debian.org/gitweb/?p=selinux/libsemanage.git;a=summary
+VCS-Git: https://anonscm.debian.org/git/selinux/libsemanage.git
+VCS-Browser: https://anonscm.debian.org/gitweb/?p=selinux/libsemanage.git;a=summary
 Priority: optional
 Section: libdevel
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
-Uploaders: Manoj Srivastava <srivasta@debian.org>, Russell Coker <russell@coker.com.au>
-Standards-Version: 3.9.5
+Uploaders: Manoj Srivastava <srivasta@debian.org>,
+           Russell Coker <russell@coker.com.au>
+Standards-Version: 3.9.8
 Build-Depends: bison,
                debhelper (>= 9),
+               dh-python,
                file,
                flex,
                gem2deb (>= 0.5.0~),
                libaudit-dev,
                libbz2-dev,
                libcunit1-dev,
-               libselinux1-dev (>= 2.3),
-               libsepol1-dev (>= 2.3),
+               libselinux1-dev (>= 2.5),
+               libsepol1-dev (>= 2.5),
                libustr-dev,
                pkg-config,
                python-all-dev (>= 2.6.6-3~),
+               python3-all-dev,
                swig
 Homepage: http://userspace.selinuxproject.org/
 X-Python-Version: >= 2.5
+X-Python3-Version: >= 3.2
 XS-Ruby-Versions: all
 
 Package: libsemanage-common
@@ -51,6 +55,9 @@
 Depends: libsemanage-common (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
+Breaks: policycoreutils (<< 2.4),
+        selinux-policy-default (<< 2:2.20140421-10~),
+        selinux-policy-mls (<< 2:2.20140421-10~)
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: SELinux policy management library
@@ -75,9 +82,9 @@
 Package: libsemanage1-dev
 Architecture: linux-any
 Depends: libbz2-dev,
-         libselinux1-dev (>= 2.3),
+         libselinux1-dev (>= 2.5),
          libsemanage1 (= ${binary:Version}),
-         libsepol1-dev (>= 2.3),
+         libsepol1-dev (>= 2.5),
          libustr-dev,
          ${misc:Depends},
          ${shlibs:Depends}
@@ -134,3 +141,45 @@
  of many kinds of mandatory access control policies, including those
  based on the concepts of Type Enforcement, Role-based Access
  Control, and Multi-level Security.
+
+Package: python3-semanage
+Architecture: linux-any
+Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Section: python
+Description: Python3 bindings for SELinux policy management
+ This package provides Python3 bindings for the management of SELinux
+ policies.
+ .
+ Security-enhanced Linux is a patch of the Linux kernel and a
+ number of utilities with enhanced security functionality designed to
+ add mandatory access controls to Linux.  The Security-enhanced Linux
+ kernel contains new architectural components originally developed to
+ improve the security of the Flask operating system. These
+ architectural components provide general support for the enforcement
+ of many kinds of mandatory access control policies, including those
+ based on the concepts of Type Enforcement, Role-based Access
+ Control, and Multi-level Security.
+
+Package: semanage-utils
+Architecture: linux-any
+Depends: libsepol1 (>= 2.5),
+         python,
+         python-selinux (>= 2.5),
+         python-semanage (>= 2.5),
+         ${misc:Depends},
+         ${python:Depends}
+Section: admin
+Description: SELinux policy management utilities
+ This package contains an utility that can be used to migrate from the old
+ policy store format (HLL, stored in /etc/selinux) to the new one (CLI, stored
+ in /var/lib/selinux).
+ .
+ Security-enhanced Linux is a patch of the Linux kernel and a
+ number of utilities with enhanced security functionality designed to
+ add mandatory access controls to Linux.  The Security-enhanced Linux
+ kernel contains new architectural components originally developed to
+ improve the security of the Flask operating system. These
+ architectural components provide general support for the enforcement
+ of many kinds of mandatory access control policies, including those
+ based on the concepts of Type Enforcement, Role-based Access
+ Control, and Multi-level Security.

## libsemanage 2.6

=== man/Makefile ===
# Installation directories.
MAN3DIR ?= $(DESTDIR)/usr/share/man/man3
MAN5DIR ?= $(DESTDIR)/usr/share/man/man5

all:

install: all
	mkdir -p $(MAN3DIR)
	mkdir -p $(MAN5DIR)
	install -m 644 man3/*.3 $(MAN3DIR)
	install -m 644 man5/*.5 $(MAN5DIR)

=== src/Makefile ===
--- 
+++ 
@@ -5,18 +5,19 @@
 PYPREFIX ?= $(notdir $(PYTHON))
 RUBY ?= ruby
 RUBYPREFIX ?= $(notdir $(RUBY))
+PKG_CONFIG ?= pkg-config
 
 # Installation directories.
 PREFIX ?= $(DESTDIR)/usr
 LIBDIR ?= $(PREFIX)/lib
-SHLIBDIR ?= $(PREFIX)/lib
+SHLIBDIR ?= $(DESTDIR)/lib
 INCLUDEDIR ?= $(PREFIX)/include
 PYLIBVER ?= $(shell $(PYTHON) -c 'import sys;print("python%d.%d" % sys.version_info[0:2])')
-PYINC ?= $(shell pkg-config --cflags $(PYPREFIX))
+PYINC ?= $(shell $(PKG_CONFIG) --cflags $(PYPREFIX))
 PYLIBDIR ?= $(LIBDIR)/$(PYLIBVER)
 RUBYLIBVER ?= $(shell $(RUBY) -e 'print RUBY_VERSION.split(".")[0..1].join(".")')
 RUBYPLATFORM ?= $(shell $(RUBY) -e 'print RUBY_PLATFORM')
-RUBYINC ?= $(shell pkg-config --cflags ruby-$(RUBYLIBVER))
+RUBYINC ?= $(shell $(PKG_CONFIG) --cflags ruby-$(RUBYLIBVER))
 RUBYINSTALL ?= $(LIBDIR)/ruby/site_ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
 
 LIBBASE=$(shell basename $(LIBDIR))
@@ -50,8 +51,8 @@
 SWIGRUBYSO=$(RUBYPREFIX)_semanage.so
 LIBSO=$(TARGET).$(LIBVERSION)
 
-GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) semanageswig_python_exception.i
-SRCS= $(filter-out $(GENERATED),$(wildcard *.c))
+GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) semanageswig_python_exception.i $(wildcard conf-*.[ch])
+SRCS= $(filter-out $(GENERATED),$(sort $(wildcard *.c)))
 
 OBJS= $(patsubst %.c,%.o,$(SRCS)) conf-scan.o conf-parse.o
 LOBJS= $(patsubst %.c,%.lo,$(SRCS)) conf-scan.lo conf-parse.lo
@@ -61,13 +62,11 @@
 		-Wno-unused-parameter
 
 override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE 
-RANLIB=ranlib
+RANLIB ?= ranlib
 
 SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./
 
 SWIGRUBY = swig -Wall -ruby -o $(SWIGRUBYCOUT) -outdir ./
-
-GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) $(wildcard conf-*.[ch])
 
 all: $(LIBA) $(LIBSO) $(LIBPC)
 
@@ -139,8 +138,7 @@
 install: all 
 	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
 	install -m 644 $(LIBA) $(LIBDIR)
-	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
-	install -m 755 $(LIBSO) $(SHLIBDIR)
+	install -m 755 $(LIBSO) $(LIBDIR)
 	test -d $(LIBDIR)/pkgconfig || install -m 755 -d $(LIBDIR)/pkgconfig
 	install -m 644 $(LIBPC) $(LIBDIR)/pkgconfig
 	test -f $(DEFAULT_SEMANAGE_CONF_LOCATION) || install -m 644 -D semanage.conf $(DEFAULT_SEMANAGE_CONF_LOCATION)
@@ -157,13 +155,13 @@
 	install -m 755 $(SWIGRUBYSO) $(RUBYINSTALL)/semanage.so
 
 relabel:
-	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)
+	/sbin/restorecon $(LIBDIR)/$(LIBSO)
 
 clean: 
 	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) conf-parse.c conf-parse.h conf-scan.c *.o *.lo *~
 
 distclean: clean
-	rm -f $(SWIGCOUT) $(SWIGFILES)
+	rm -f $(GENERATED) $(SWIGFILES)
 
 indent:
 	../../scripts/Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))

=== tests/Makefile ===
--- 
+++ 
@@ -10,10 +10,9 @@
 ###########################################################################
 
 EXECUTABLE = libsemanage-tests
-CC = gcc
-CFLAGS = -c -g -o0 -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute -Wno-unused-parameter
+CFLAGS += -g -O0 -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute -Wno-unused-parameter
 INCLUDE = -I$(TESTSRC) -I$(TESTSRC)/../include
-LDFLAGS = -lcunit -lustr -lbz2 -laudit
+LDFLAGS += -lcunit -lustr -lbz2 -laudit
 OBJECTS = $(SOURCES:.c=.o) 
 
 all: $(EXECUTABLE) 
@@ -22,7 +21,7 @@
 	$(CC) $(OBJECTS) $(LIBS) $(LDFLAGS) -o $@
 
 %.o: %.c
-	$(CC) $(CFLAGS) $(INCLUDE) $*.c -o $*.o
+	$(CC) $(CFLAGS) $(INCLUDE) -c $*.c -o $*.o
 
 clean distclean: 
 	rm -rf $(OBJECTS) $(EXECUTABLE)

=== debian/control ===
--- 
+++ 
@@ -16,8 +16,8 @@
                libaudit-dev,
                libbz2-dev,
                libcunit1-dev,
-               libselinux1-dev (>= 2.5),
-               libsepol1-dev (>= 2.5),
+               libselinux1-dev (>= 2.6),
+               libsepol1-dev (>= 2.6),
                libustr-dev,
                pkg-config,
                python-all-dev (>= 2.6.6-3~),
@@ -82,9 +82,9 @@
 Package: libsemanage1-dev
 Architecture: linux-any
 Depends: libbz2-dev,
-         libselinux1-dev (>= 2.5),
+         libselinux1-dev (>= 2.6),
          libsemanage1 (= ${binary:Version}),
-         libsepol1-dev (>= 2.5),
+         libsepol1-dev (>= 2.6),
          libustr-dev,
          ${misc:Depends},
          ${shlibs:Depends}
@@ -162,10 +162,10 @@
 
 Package: semanage-utils
 Architecture: linux-any
-Depends: libsepol1 (>= 2.5),
+Depends: libsepol1 (>= 2.6),
          python,
-         python-selinux (>= 2.5),
-         python-semanage (>= 2.5),
+         python-selinux (>= 2.6),
+         python-semanage (>= 2.6),
          ${misc:Depends},
          ${python:Depends}
 Section: admin

=== debian/watch ===
version=3

https://github.com/SELinuxProject/selinux/wiki/Releases (?:.*)/releases/(?:\d*)/libsemanage-([\d\.]*)\.tar\.gz

## libsemanage 2.7

=== src/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # runtimes (e.g. Python 2 vs Python 3) by optionally prefixing the build
 # targets with "PYPREFIX":
 PYTHON ?= python
-PYPREFIX ?= $(notdir $(PYTHON))
+PYPREFIX ?= $(shell $(PYTHON) -c 'import sys;print("python-%d.%d" % sys.version_info[:2])')
 RUBY ?= ruby
 RUBYPREFIX ?= $(notdir $(RUBY))
 PKG_CONFIG ?= pkg-config
@@ -12,13 +12,13 @@
 LIBDIR ?= $(PREFIX)/lib
 SHLIBDIR ?= $(DESTDIR)/lib
 INCLUDEDIR ?= $(PREFIX)/include
-PYLIBVER ?= $(shell $(PYTHON) -c 'import sys;print("python%d.%d" % sys.version_info[0:2])')
 PYINC ?= $(shell $(PKG_CONFIG) --cflags $(PYPREFIX))
-PYLIBDIR ?= $(LIBDIR)/$(PYLIBVER)
-RUBYLIBVER ?= $(shell $(RUBY) -e 'print RUBY_VERSION.split(".")[0..1].join(".")')
-RUBYPLATFORM ?= $(shell $(RUBY) -e 'print RUBY_PLATFORM')
-RUBYINC ?= $(shell $(PKG_CONFIG) --cflags ruby-$(RUBYLIBVER))
-RUBYINSTALL ?= $(LIBDIR)/ruby/site_ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
+PYLIBS ?= $(shell $(PKG_CONFIG) --libs $(PYPREFIX))
+PYSITEDIR ?= $(DESTDIR)$(shell $(PYTHON) -c 'import site; print(site.getsitepackages()[0])')
+PYCEXT ?= $(shell $(PYTHON) -c 'import imp;print([s for s,m,t in imp.get_suffixes() if t == imp.C_EXTENSION][0])')
+RUBYINC ?= $(shell $(RUBY) -e 'puts "-I" + RbConfig::CONFIG["rubyarchhdrdir"] + " -I" + RbConfig::CONFIG["rubyhdrdir"]')
+RUBYLIBS ?= $(shell $(RUBY) -e 'puts "-L" + RbConfig::CONFIG["libdir"] + " -L" + RbConfig::CONFIG["archlibdir"] + " " + RbConfig::CONFIG["LIBRUBYARG_SHARED"]')
+RUBYINSTALL ?= $(DESTDIR)$(shell $(RUBY) -e 'puts RbConfig::CONFIG["vendorarchdir"]')
 
 LIBBASE=$(shell basename $(LIBDIR))
 
@@ -51,7 +51,7 @@
 SWIGRUBYSO=$(RUBYPREFIX)_semanage.so
 LIBSO=$(TARGET).$(LIBVERSION)
 
-GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) semanageswig_python_exception.i $(wildcard conf-*.[ch])
+GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) semanageswig_python_exception.i $(sort $(wildcard conf-*.[ch]))
 SRCS= $(filter-out $(GENERATED),$(sort $(wildcard *.c)))
 
 OBJS= $(patsubst %.c,%.o,$(SRCS)) conf-scan.o conf-parse.o
@@ -61,7 +61,7 @@
 SWIG_CFLAGS += -Wno-error -Wno-unused-but-set-variable -Wno-unused-variable -Wno-shadow \
 		-Wno-unused-parameter
 
-override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE 
+override CFLAGS += -I../include -D_GNU_SOURCE
 RANLIB ?= ranlib
 
 SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./
@@ -81,27 +81,27 @@
 	$(CC) $(CFLAGS) $(SWIG_CFLAGS) $(RUBYINC) -fPIC -DSHARED -c -o $@ $<
 
 $(SWIGSO): $(SWIGLOBJ)
-	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $< -L. -lsemanage -L$(LIBDIR)
+	$(CC) $(CFLAGS) $(LDFLAGS) -L. -shared -o $@ $< -lsemanage $(PYLIBS)
 
 $(SWIGRUBYSO): $(SWIGRUBYLOBJ)
-	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lsemanage -L$(LIBDIR)
+	$(CC) $(CFLAGS) $(LDFLAGS) -L. -shared -o $@ $^ -lsemanage $(RUBYLIBS)
 
 $(LIBA): $(OBJS)
 	$(AR) rcs $@ $^
 	$(RANLIB) $@
 
 $(LIBSO): $(LOBJS)
-	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -lsepol -laudit -lselinux -lbz2 -lustr -L$(LIBDIR) -Wl,-soname,$(LIBSO),--version-script=libsemanage.map,-z,defs
+	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -lsepol -laudit -lselinux -lbz2 -Wl,-soname,$(LIBSO),--version-script=libsemanage.map,-z,defs
 	ln -sf $@ $(TARGET)
 
 $(LIBPC): $(LIBPC).in ../VERSION
 	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBBASE):; s:@includedir@:$(INCLUDEDIR):' < $< > $@
 
 semanageswig_python_exception.i: ../include/semanage/semanage.h
-	bash exception.sh > $@
+	bash -e exception.sh > $@ || (rm -f $@ ; false)
 
 conf-scan.c: conf-scan.l conf-parse.h
-	$(LEX) $(LFLAGS) -t $< > $@
+	$(LEX) $(LFLAGS) -o $@ $<
 
 conf-parse.c: conf-parse.y
 	$(YACC) $(YFLAGS) -o $@ $<
@@ -145,9 +145,9 @@
 	cd $(LIBDIR) && ln -sf $(LIBSO) $(TARGET)
 
 install-pywrap: pywrap 
-	test -d $(PYLIBDIR)/site-packages || install -m 755 -d $(PYLIBDIR)/site-packages
-	install -m 755 $(SWIGSO) $(PYLIBDIR)/site-packages/_semanage.so
-	install -m 755 semanage.py $(PYLIBDIR)/site-packages
+	test -d $(PYSITEDIR) || install -m 755 -d $(PYSITEDIR)
+	install -m 755 $(SWIGSO) $(PYSITEDIR)/_semanage$(PYCEXT)
+	install -m 644 semanage.py $(PYSITEDIR)
 
 
 install-rubywrap: rubywrap
@@ -158,7 +158,7 @@
 	/sbin/restorecon $(LIBDIR)/$(LIBSO)
 
 clean: 
-	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) conf-parse.c conf-parse.h conf-scan.c *.o *.lo *~
+	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(SWIGRUBYSO) $(TARGET) conf-parse.c conf-parse.h conf-scan.c *.o *.lo *~
 
 distclean: clean
 	rm -f $(GENERATED) $(SWIGFILES)

=== tests/Makefile ===
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib

# Add your test source files here:
SOURCES = $(sort $(wildcard *.c))

###########################################################################

EXECUTABLE = libsemanage-tests
CFLAGS += -g -O0 -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute -Wno-unused-parameter
override CFLAGS += -I../src -I../include
override LDLIBS += -lcunit -lbz2 -laudit -lselinux -lsepol

OBJECTS = $(SOURCES:.c=.o) 

all: $(EXECUTABLE) 

$(EXECUTABLE): $(OBJECTS) ../src/libsemanage.a
	$(CC) $(LDFLAGS) -o $@ $^ $(LDLIBS)

clean distclean: 
	rm -rf $(OBJECTS) $(EXECUTABLE)

test: all 
	./$(EXECUTABLE)

=== debian/changelog ===
libsemanage (2.7-2build2) bionic; urgency=high

  * No change rebuild against ruby-defaults without ruby2.3 support.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 01 Mar 2018 09:35:15 +0000

libsemanage (2.7-2build1) bionic; urgency=medium

  * No-change rebuild for ruby2.5 update.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 01 Feb 2018 19:01:52 +0000

libsemanage (2.7-2) unstable; urgency=medium

  [ Laurent Bigonville ]
  * debian/control: Drop libustr-dev (build-)dependency, not used anymore
  * debian/rules: Make the tests failures fatal again, tests don't seems to
    fail anymore

  [ Helmut Grohne ]
  * Support being built with multiple build profiles. (Closes: #875551)
  * Support nocheck build profile. (Closes: #875558)
  * Fix stage1 FTCBFS: Export triplet-prefixed CC. (Closes: #875559)
  * Use profiles nopython and noruby rather than stage1. (Closes: #875562)

 -- Laurent Bigonville <bigon@debian.org>  Fri, 15 Sep 2017 15:14:34 +0200

libsemanage (2.7-1) unstable; urgency=medium

  * New upstream release
    - debian/control: Bump {build-}dependencies to match new release
  * debian/control: Remove Manoj from the uploader list and add myself
    instead. Thanks to him for all the work in the past.
  * Bump debhelper compatibility to 10
  * Bump Standards-Version to 4.1.0 (no further changes)
  * Convert DEB_STAGE to DEB_BUILD_PROFILES

 -- Laurent Bigonville <bigon@debian.org>  Sun, 10 Sep 2017 01:07:48 +0200

libsemanage (2.7~rc2-1) experimental; urgency=medium

  * Team upload.
  * New upstream release candidate
    - debian/control: Bump {build-}dependencies to match new release
    - Drop debian/patches/fix_use-after-free_python3.patch, applied upstream
    - Drop debian/patches/tests-makefile: Not needed anymore
    - debian/libsemanage1.symbols: Update the exported symbols list
  * Use python3 for semanage_migrate_store
  * debian/watch: Add support for rc releases and use macros
  * debian/control: Bump Standards-Version to 4.0.0 (no further changes)
  * debian/rules: Fix the build of the ruby binding
  * debian/rules: Fix the build of the python binding

 -- Laurent Bigonville <bigon@debian.org>  Wed, 21 Jun 2017 21:56:16 +0200

libsemanage (2.6-2) unstable; urgency=medium

  * Team upload.
  * debian/patches/fix_use-after-free_python3.patch: Fix use-after-free when
    using python3 bindings, this was preventing to modify/delete login
    mappings, from upstream (Closes: #848232)

 -- Laurent Bigonville <bigon@debian.org>  Fri, 30 Dec 2016 16:42:09 +0100

libsemanage (2.6-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Make the build reproducible (Closes: #825674)
    - debian/control: Bump {build-}dependencies to match new release
  * debian/libsemanage1.symbols: Add the Build-Depends-Package field
  * debian/gbp.conf: Rename git-buildpackage section to buildpackage

 -- Laurent Bigonville <bigon@debian.org>  Sat, 29 Oct 2016 19:47:52 +0200

libsemanage (2.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - debian/control: Bump {build-}dependencies to match new release
    - debian/patches/semigrate-store.patch: Refreshed
    - debian/libsemanage1.symbols: Add new exported symbol
  * debian/gbp.conf: Sign tags by default
  * debian/control: Bump Standards-Version to 3.9.8 (no further changes)
  * debian/control: Update the Vcs-* URL's to please lintian (again)

 -- Laurent Bigonville <bigon@debian.org>  Mon, 25 Apr 2016 20:14:10 +0200

libsemanage (2.4-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable
  * debian/control:
    - Add a Breaks against policycoreutils << 2.4, if the package is installed,
      let's be sure we have the correct version.
    - Add Breaks against the policy packages, libsemanage 2.4 introduce a new
      location for the policy store and the maintainer scripts from the policy
      packages need to be adjusted.

 -- Laurent Bigonville <bigon@debian.org>  Thu, 19 Nov 2015 01:58:47 +0100

libsemanage (2.4-2) experimental; urgency=medium

  * Team upload.
  * Create a new semanage-utils package and install semanage_migrate_store
    utility in it. This utility can be used to migrate the policy store to the
    new format and location.
  * Add d/p/semigrate-store.patch: Fix the soname of the libsepol library and
    debianize the name of the packages to install in an error message

 -- Laurent Bigonville <bigon@debian.org>  Tue, 27 Oct 2015 17:12:24 +0100

libsemanage (2.4-1) experimental; urgency=medium

  * Team upload.
  * New upstream release
    - debian/patches/disable-expand-check.patch: Refreshed
    - debian/control: Bump {build-}dependencies to match new release
    - Adjust the debian/libsemanage1.symbols file
  * debian/watch: Update watch file URL
  * debian/control: Bump Standards-Version to 3.9.6 (no further changes)
  * Do not look for hll compiler in /usr/libexec
  * Start building python3 packages

 -- Laurent Bigonville <bigon@debian.org>  Fri, 31 Jul 2015 16:21:13 +0200

=== debian/control ===
--- 
+++ 
@@ -3,26 +3,26 @@
 VCS-Browser: https://anonscm.debian.org/gitweb/?p=selinux/libsemanage.git;a=summary
 Priority: optional
 Section: libdevel
-Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
-Uploaders: Manoj Srivastava <srivasta@debian.org>,
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
+Uploaders: Laurent Bigonville <bigon@debian.org>,
            Russell Coker <russell@coker.com.au>
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Build-Depends: bison,
-               debhelper (>= 9),
-               dh-python,
+               debhelper (>= 10),
+               dh-python <!nopython>,
                file,
                flex,
-               gem2deb (>= 0.5.0~),
+               gem2deb (>= 0.5.0~) <!noruby>,
                libaudit-dev,
                libbz2-dev,
-               libcunit1-dev,
-               libselinux1-dev (>= 2.6),
-               libsepol1-dev (>= 2.6),
-               libustr-dev,
+               libcunit1-dev <!nocheck>,
+               libselinux1-dev (>= 2.7),
+               libsepol1-dev (>= 2.7),
                pkg-config,
-               python-all-dev (>= 2.6.6-3~),
-               python3-all-dev,
-               swig
+               python-all-dev (>= 2.6.6-3~) <!nopython>,
+               python3-all-dev <!nopython>,
+               swig <!nopython> <!noruby>
 Homepage: http://userspace.selinuxproject.org/
 X-Python-Version: >= 2.5
 X-Python3-Version: >= 3.2
@@ -82,10 +82,9 @@
 Package: libsemanage1-dev
 Architecture: linux-any
 Depends: libbz2-dev,
-         libselinux1-dev (>= 2.6),
+         libselinux1-dev (>= 2.7),
          libsemanage1 (= ${binary:Version}),
-         libsepol1-dev (>= 2.6),
-         libustr-dev,
+         libsepol1-dev (>= 2.7),
          ${misc:Depends},
          ${shlibs:Depends}
 Provides: libsemanage-dev
@@ -109,6 +108,7 @@
 Architecture: linux-any
 Depends: ruby | ruby-interpreter, ${misc:Depends}, ${shlibs:Depends}
 Section: ruby
+Build-Profiles: <!noruby>
 XB-Ruby-Versions: ${ruby:Versions}
 Description: Ruby bindings to for SELinux policy management
  This package provides the Ruby bindings needed for developing Ruby
@@ -128,6 +128,7 @@
 Architecture: linux-any
 Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
 Section: python
+Build-Profiles: <!nopython>
 Description: Python bindings for SELinux policy management
  This package provides Python bindings for the management of SELinux
  policies.
@@ -146,6 +147,7 @@
 Architecture: linux-any
 Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
 Section: python
+Build-Profiles: <!nopython>
 Description: Python3 bindings for SELinux policy management
  This package provides Python3 bindings for the management of SELinux
  policies.
@@ -162,12 +164,12 @@
 
 Package: semanage-utils
 Architecture: linux-any
-Depends: libsepol1 (>= 2.6),
-         python,
-         python-selinux (>= 2.6),
-         python-semanage (>= 2.6),
+Depends: libsepol1 (>= 2.7),
+         python3 (>= 3.2),
+         python3-selinux (>= 2.7),
+         python3-semanage (>= 2.7),
          ${misc:Depends},
-         ${python:Depends}
+         ${python3:Depends}
 Section: admin
 Description: SELinux policy management utilities
  This package contains an utility that can be used to migrate from the old

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk
ifeq ($(origin CC),default)
CC := $(DEB_HOST_GNU_TYPE)-gcc
endif
export CC

DOPACKAGES = $(shell dh_listpackages)

DH_ADDONS=
ifneq ($(filter python-semanage,$(DOPACKAGES)),)
PYVERSIONS = $(shell pyversions -rv)
DH_ADDONS += --with=python2
endif
ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
PY3VERSIONS = $(shell py3versions -rv)
DH_ADDONS += --with=python3
endif
ifneq ($(filter ruby-semanage,$(DOPACKAGES)),)
RUBY_VERSIONS := $(shell dh_ruby --print-supported)
DH_ADDONS += --with=ruby
endif

# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

%:
	dh $@ $(DH_ADDONS)

override_dh_auto_build:
	$(MAKE) all LIBBASE="lib/${DEB_HOST_MULTIARCH}" SELINUXEXECDIR="usr/lib/selinux"

ifneq ($(filter python-semanage,$(DOPACKAGES)),)
	set -e; for version in $(PYVERSIONS); do         \
	  $(MAKE) pywrap PYTHON=python$$version PYLIBS=; \
	done;
endif
ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
	set -e; for version in $(PY3VERSIONS); do        \
	  $(MAKE) pywrap PYTHON=python$$version PYLIBS=; \
	done;
endif
ifneq ($(filter ruby-semanage,$(DOPACKAGES)),)
	set -e; for version in $(RUBY_VERSIONS); do      \
	  $(MAKE) -C src rubywrap RUBY=$$version \
	    RUBYLIBS="$$($$version -e 'puts "-L" + RbConfig::CONFIG["archlibdir"] + " " + RbConfig::CONFIG["LIBRUBYARG_SHARED"]')"; \
	done;
endif

override_dh_auto_install:
	$(MAKE) install DESTDIR="${CURDIR}/debian/tmp" \
	  LIBDIR="${CURDIR}/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}" \
	  SHLIBDIR="${CURDIR}/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}" \
	  SELINUXEXECDIR="${CURDIR}/debian/tmp/usr/lib/selinux"

ifneq ($(filter python-semanage,$(DOPACKAGES)),)
	set -e; for version in $(PYVERSIONS); do         \
	  $(MAKE) install-pywrap PYTHON=python$$version  \
	    PYSITEDIR="${CURDIR}/debian/tmp/usr/lib/python$$version/dist-packages"; \
	done;
endif
ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
	set -e; for version in $(PY3VERSIONS); do        \
	  $(MAKE) install-pywrap PYTHON=python$$version  \
	    PYSITEDIR="${CURDIR}/debian/tmp/usr/lib/python$$version/dist-packages"; \
	done;
endif
ifneq ($(filter ruby-semanage,$(DOPACKAGES)),)
	set -e; for version in $(RUBY_VERSIONS); do      \
	  $(MAKE) -C src install-rubywrap RUBY=$$version DESTDIR="${CURDIR}/debian/tmp"; \
	done;
endif

override_dh_auto_clean:
ifneq ($(filter python-semanage,$(DOPACKAGES)),)
	set -e; for version in $(PYVERSIONS); do         \
	  $(MAKE) clean PYTHON=python$$version;  \
	done;
endif

override_dh_install:
	dh_install --list-missing

override_dh_fixperms:
	dh_fixperms
ifneq ($(filter python-semanage,$(DOPACKAGES)),)
	chmod -x ${CURDIR}/debian/python-semanage/usr/lib/python*/*-packages/semanage.py
endif
ifneq ($(filter python3-semanage,$(DOPACKAGES)),)
	chmod -x ${CURDIR}/debian/python3-semanage/usr/lib/python*/*-packages/semanage.py
endif
